Index: channels/chan_iax2.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_iax2.c,v
retrieving revision 1.294
diff -u -r1.294 chan_iax2.c
--- channels/chan_iax2.c	19 May 2005 04:31:02 -0000	1.294
+++ channels/chan_iax2.c	25 May 2005 21:09:27 -0000
@@ -71,6 +71,14 @@
 #include "iax2-provision.h"
 #include "astconf.h"
 
+static struct ast_crypto *ast_crypto;
+static struct ast_features *ast_features;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_crypto),
+        MOD_WANT(ast_features),
+        { NULL, NULL }
+};
+
 /* Define NEWJB to use the new channel independent jitterbuffer,
  * otherwise, use the old jitterbuffer */
 #define NEWJB
@@ -4926,8 +4934,8 @@
 		stringp=tmpkey;
 		keyn = strsep(&stringp, ":");
 		while(keyn) {
-			key = ast_key_get(keyn, AST_KEY_PUBLIC);
-			if (key && !ast_check_signature(key, p->challenge, rsasecret)) {
+			key = ast_crypto->ast_key_get(keyn, AST_KEY_PUBLIC);
+			if (key && !ast_crypto->ast_check_signature(key, p->challenge, rsasecret)) {
 				res = 0;
 				break;
 			} else if (!key)
@@ -5030,8 +5038,8 @@
 			stringp=tmpkeys;
 			keyn = strsep(&stringp, ":");
 			while(keyn) {
-				key = ast_key_get(keyn, AST_KEY_PUBLIC);
-				if (key && !ast_check_signature(key, iaxs[callno]->challenge, rsasecret)) {
+				key = ast_crypto->ast_key_get(keyn, AST_KEY_PUBLIC);
+				if (key && !ast_crypto->ast_check_signature(key, iaxs[callno]->challenge, rsasecret)) {
 					iaxs[callno]->state |= IAX_STATE_AUTHENTICATED;
 					break;
 				} else if (!key) 
@@ -5122,11 +5130,11 @@
 		} else {
 			char sig[256];
 			struct ast_key *key;
-			key = ast_key_get(keyn, AST_KEY_PRIVATE);
+			key = ast_crypto->ast_key_get(keyn, AST_KEY_PRIVATE);
 			if (!key) {
 				ast_log(LOG_NOTICE, "Unable to find private key '%s'\n", keyn);
 			} else {
-				if (ast_sign(key, challenge, sig)) {
+				if (ast_crypto->ast_sign(key, challenge, sig)) {
 					ast_log(LOG_NOTICE, "Unable to sign challenge withy key\n");
 					res = -1;
 				} else {
@@ -5989,7 +5997,7 @@
 	memset(&ied1, 0, sizeof(ied1));
 	mm = ast_matchmore_extension(NULL, context, callednum, 1, callerid);
 	/* Must be started */
-	if (!strcmp(callednum, ast_parking_ext()) || ast_exists_extension(NULL, context, callednum, 1, callerid)) {
+	if (!strcmp(callednum, ast_features->ast_parking_ext()) || ast_exists_extension(NULL, context, callednum, 1, callerid)) {
 		dpstatus = IAX_DPSTATUS_EXISTS;
 	} else if (ast_canmatch_extension(NULL, context, callednum, 1, callerid)) {
 		dpstatus = IAX_DPSTATUS_CANEXIST;
@@ -6061,7 +6069,7 @@
 	f = ast_read(chan1);
 	if (f)
 		ast_frfree(f);
-	res = ast_park_call(chan1, chan2, 0, &ext);
+	res = ast_features->ast_park_call(chan1, chan2, 0, &ext);
 	ast_hangup(chan2);
 	ast_log(LOG_DEBUG, "Parked on extension '%d'\n", ext);
 	return NULL;
@@ -6889,7 +6897,7 @@
 				break;
 			case IAX_COMMAND_TRANSFER:
 				if (iaxs[fr.callno]->owner && ast_bridged_channel(iaxs[fr.callno]->owner) && ies.called_number) {
-					if (!strcmp(ies.called_number, ast_parking_ext())) {
+					if (!strcmp(ies.called_number, ast_features->ast_parking_ext())) {
 						if (iax_park(ast_bridged_channel(iaxs[fr.callno]->owner), iaxs[fr.callno]->owner)) {
 							ast_log(LOG_WARNING, "Failed to park call on '%s'\n", ast_bridged_channel(iaxs[fr.callno]->owner)->name);
 						} else
Index: channels/chan_mgcp.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_mgcp.c,v
retrieving revision 1.121
diff -u -r1.121 chan_mgcp.c
--- channels/chan_mgcp.c	15 May 2005 03:21:51 -0000	1.121
+++ channels/chan_mgcp.c	25 May 2005 21:09:31 -0000
@@ -137,6 +137,12 @@
 #define MGCP_CX_MUTE		4
 #define MGCP_CX_INACTIVE	4
 
+static struct   ast_features *ast_features;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_features),
+        {NULL, NULL}
+};
+
 static char *mgcp_cxmodes[] = {
 	"sendonly",
 	"recvonly",
@@ -2664,12 +2670,12 @@
 			len = 0;
 			memset(exten, 0, sizeof(exten));
 			timeout = firstdigittimeout;
-		} else if (!strcmp(exten,ast_pickup_ext())) {
+		} else if (!strcmp(exten, ast_features->ast_pickup_ext())) {
 			/* Scan all channels and see if any there
 			 * ringing channqels with that have call groups
 			 * that equal this channels pickup group  
 			 */
-			if (ast_pickup_call(chan)) {
+			if ( ast_features->ast_pickup_call(chan)) {
 				ast_log(LOG_WARNING, "No call pickup possible...\n");
 				/*res = tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_CONGESTION);*/
 				transmit_notify_request(sub, "G/cg");
@@ -2740,11 +2746,11 @@
 			getforward = 0;
 			memset(exten, 0, sizeof(exten));
 			len = 0;
-		} else if (!strcmp(exten, ast_parking_ext()) && 
+		} else if (!strcmp(exten,  ast_features->ast_parking_ext()) && 
 			sub->next->owner && ast_bridged_channel(sub->next->owner)) {
 			/* This is a three way call, the main call being a real channel, 
 			   and we're parking the first call. */
-			ast_masq_park_call(ast_bridged_channel(sub->next->owner), chan, 0, NULL);
+			ast_features->ast_masq_park_call(ast_bridged_channel(sub->next->owner), chan, 0, NULL);
 			if (option_verbose > 2) {
 				ast_verbose(VERBOSE_PREFIX_3 "Parking call to '%s'\n", chan->name);
 			}
Index: channels/chan_modem.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_modem.c,v
retrieving revision 1.39
diff -u -r1.39 chan_modem.c
--- channels/chan_modem.c	21 Apr 2005 06:02:43 -0000	1.39
+++ channels/chan_modem.c	25 May 2005 21:09:31 -0000
@@ -173,14 +173,14 @@
 	return mc;
 }
 
-int ast_register_modem_driver(struct ast_modem_driver *mc)
+int ast_modem_register_driver(struct ast_modem_driver *mc)
 {
 	mc->next = drivers;
 	drivers = mc;
 	return 0;
 }
 
-int ast_unregister_modem_driver(struct ast_modem_driver *mc)
+int ast_modem_unregister_driver(struct ast_modem_driver *mc)
 {
 	struct ast_modem_driver *last = NULL, *cur;
 	cur = drivers;
@@ -1097,3 +1097,18 @@
 	return ASTERISK_GPL_KEY;
 }
 
+#define	METHOD(x)	METHOD_BASE(ast_modem_, x)
+static struct ast_modem ast_modem = {
+	METHOD(register_driver),
+	METHOD(unregister_driver),
+	METHOD(send),
+	METHOD(expect),
+	METHOD(read_response),
+	METHOD(new),
+	METHOD(trim),
+};
+
+struct symbol_entry exported_symbols[] = {
+	MOD_DATA(ast_modem),
+	{ NULL, NULL }
+};
Index: channels/chan_modem_aopen.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_modem_aopen.c,v
retrieving revision 1.14
diff -u -r1.14 chan_modem_aopen.c
--- channels/chan_modem_aopen.c	21 Apr 2005 06:02:43 -0000	1.14
+++ channels/chan_modem_aopen.c	25 May 2005 21:09:32 -0000
@@ -29,6 +29,13 @@
 #define VRA "40"			/* Number of 100ms of non-ring after a ring cadence after which we consider the lien to be answered */
 #define VRN "100"			/* Number of 100ms of non-ring with no cadence after which we assume an answer */
 
+static struct ast_modem *ast_modem;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_modem),
+        { NULL, NULL }
+};
+
+
 static char *breakcmd = "\0x10\0x03";
 
 static char *desc = "A/Open (Rockwell Chipset) ITU-2 VoiceModem Driver";
@@ -45,17 +52,17 @@
 static int aopen_setdev(struct ast_modem_pvt *p, int dev)
 {
 	char cmd[80];
-	if (ast_modem_send(p, "AT#VLS?", 0)) {
+	if (ast_modem->send(p, "AT#VLS?", 0)) {
 		ast_log(LOG_WARNING, "Unable to select current mode %d\n", dev);
 		return -1;
 	}
-	if (ast_modem_read_response(p, 5)) {
+	if (ast_modem->read_response(p, 5)) {
 		ast_log(LOG_WARNING, "Unable to select device %d\n", dev);
 		return -1;
 	}
-	ast_modem_trim(p->response);
+	ast_modem->trim(p->response);
 	strncpy(cmd, p->response, sizeof(cmd)-1);
-	if (ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Modem did not respond properly\n");
 		return -1;
 	}
@@ -65,15 +72,15 @@
 		return 0;
 	}
 	snprintf(cmd, sizeof(cmd), "AT#VLS=%d", dev);
-	if (ast_modem_send(p, cmd, 0))  {
+	if (ast_modem->send(p, cmd, 0))  {
 		ast_log(LOG_WARNING, "Unable to select device %d\n", dev);
 		return -1;
 	}
-	if (ast_modem_read_response(p, 5)) {
+	if (ast_modem->read_response(p, 5)) {
 		ast_log(LOG_WARNING, "Unable to select device %d\n", dev);
 		return -1;
 	}
-	ast_modem_trim(p->response);
+	ast_modem->trim(p->response);
 	if (strcasecmp(p->response, "VCON") && strcasecmp(p->response, "OK")) {
 		ast_log(LOG_WARNING, "Unexpected reply: %s\n", p->response);
 		return -1;
@@ -83,8 +90,8 @@
 
 static int aopen_startrec(struct ast_modem_pvt *p)
 {
-	if (ast_modem_send(p, "AT#VRX", 0) ||
-	     ast_modem_expect(p, "CONNECT", 5)) {
+	if (ast_modem->send(p, "AT#VRX", 0) ||
+	     ast_modem->expect(p, "CONNECT", 5)) {
 		ast_log(LOG_WARNING, "Unable to start recording\n");
 		return -1;
 	}
@@ -94,33 +101,33 @@
 
 static int aopen_break(struct ast_modem_pvt *p)
 {
-	if (ast_modem_send(p, "\r\n", 2)) {
+	if (ast_modem->send(p, "\r\n", 2)) {
 		ast_log(LOG_WARNING, "Failed to send enter?\n");
 		return -1;
 	}
-	if (ast_modem_send(p, breakcmd, 2)) {
+	if (ast_modem->send(p, breakcmd, 2)) {
 		ast_log(LOG_WARNING, "Failed to break\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "\r\n", 2)) {
+	if (ast_modem->send(p, "\r\n", 2)) {
 		ast_log(LOG_WARNING, "Failed to send enter?\n");
 		return -1;
 	}
 	/* Read any outstanding junk */
-	while(!ast_modem_read_response(p, 1));
-	if (ast_modem_send(p, "AT", 0)) {
+	while(!ast_modem->read_response(p, 1));
+	if (ast_modem->send(p, "AT", 0)) {
 		/* Modem might be stuck in some weird mode, try to get it out */
-		ast_modem_send(p, "+++", 3);
-		if (ast_modem_expect(p, "OK", 10)) {
+		ast_modem->send(p, "+++", 3);
+		if (ast_modem->expect(p, "OK", 10)) {
 			ast_log(LOG_WARNING, "Modem is not responding\n");
 			return -1;
 		}
-		if (ast_modem_send(p, "AT", 0)) {
+		if (ast_modem->send(p, "AT", 0)) {
 			ast_log(LOG_WARNING, "Modem is not responding\n");
 			return -1;
 		}
 	}
-	if (ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Modem did not respond properly\n");
 		return -1;
 	}
@@ -135,43 +142,43 @@
 		return -1;
 	/* Force into command mode */
 	p->ministate = STATE_COMMAND;
-	if (ast_modem_send(p, "AT#BDR=0", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#BDR=0", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to auto-baud\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT#CLS=8", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#CLS=8", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to voice mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT#VBS=8", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#VBS=8", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to 8-bit mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT#VSR=8000", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#VSR=8000", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to 8000 Hz sampling\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT#VLS=0", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#VLS=0", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to telco interface\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT#VRA=" VRA, 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#VRA=" VRA, 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to 'ringback goes away' timer\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT#VRN=" VRN, 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#VRN=" VRN, 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to 'ringback never came timer'\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT#VTD=3F,3F,3F", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#VTD=3F,3F,3F", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to tone detection\n");
 		return -1;
 	}
@@ -214,7 +221,7 @@
 		return &p->fr;
 	case 'o': /* Overrun */
 		ast_log(LOG_WARNING, "Overflow on modem, flushing buffers\n");
-		if (ast_modem_send(p, "\0x10E", 2)) 
+		if (ast_modem->send(p, "\0x10E", 2)) 
 			ast_log(LOG_WARNING, "Unable to flush buffers\n");
 		return &p->fr;	
 	case 'u': /* Underrun */
@@ -256,7 +263,7 @@
 				return aopen_handle_escape(p, 0);
 			/* Read the rest of the line */
 			fgets(result + 2, sizeof(result) - 2, p->f);
-			ast_modem_trim(result);
+			ast_modem->trim(result);
 			if (!strcasecmp(result, "VCON")) {
 				/* If we're in immediate mode, reply now */
 				if (p->mode == MODEM_MODE_IMMEDIATE)
@@ -346,21 +353,21 @@
 	char mfr[80];
 	char mdl[80];
 	char rev[80];
-	ast_modem_send(p, "AT#MDL?", 0);
-	ast_modem_read_response(p, 5);
+	ast_modem->send(p, "AT#MDL?", 0);
+	ast_modem->read_response(p, 5);
 	strncpy(mdl, p->response, sizeof(mdl)-1);
-	ast_modem_trim(mdl);
-	ast_modem_expect(p, "OK", 5);
-	ast_modem_send(p, "AT#MFR?", 0);
-	ast_modem_read_response(p, 5);
+	ast_modem->trim(mdl);
+	ast_modem->expect(p, "OK", 5);
+	ast_modem->send(p, "AT#MFR?", 0);
+	ast_modem->read_response(p, 5);
 	strncpy(mfr, p->response, sizeof(mfr)-1);
-	ast_modem_trim(mfr);
-	ast_modem_expect(p, "OK", 5);
-	ast_modem_send(p, "AT#REV?", 0);
-	ast_modem_read_response(p, 5);
+	ast_modem->trim(mfr);
+	ast_modem->expect(p, "OK", 5);
+	ast_modem->send(p, "AT#REV?", 0);
+	ast_modem->read_response(p, 5);
 	strncpy(rev, p->response, sizeof(rev)-1);
-	ast_modem_trim(rev);
-	ast_modem_expect(p, "OK", 5);
+	ast_modem->trim(rev);
+	ast_modem->expect(p, "OK", 5);
 	snprintf(identity, sizeof(identity), "%s Model %s Revision %s", mfr, mdl, rev);
 	return strdup(identity);
 }
@@ -383,8 +390,8 @@
 
 static int aopen_answer(struct ast_modem_pvt *p)
 {
-	if (ast_modem_send(p, "ATA", 0) ||
-	     ast_modem_expect(p, "VCON", 10)) {
+	if (ast_modem->send(p, "ATA", 0) ||
+	     ast_modem->expect(p, "VCON", 10)) {
 		ast_log(LOG_WARNING, "Unable to answer: %s", p->response);
 		return -1;
 	}
@@ -395,8 +402,8 @@
 {
 	char cmd[80];
 	snprintf(cmd, sizeof(cmd), "AT#VTS=%c", digit);
-	if (ast_modem_send(p, cmd, 0) ||
-	     ast_modem_expect(p, "VCON", 10)) {
+	if (ast_modem->send(p, cmd, 0) ||
+	     ast_modem->expect(p, "VCON", 10)) {
 		ast_log(LOG_WARNING, "Unable to answer: %s", p->response);
 		return -1;
 	}
@@ -407,7 +414,7 @@
 {
 	char cmd[80];
 	snprintf(cmd, sizeof(cmd), "ATD%c %s", p->dialtype,stuff);
-	if (ast_modem_send(p, cmd, 0)) {
+	if (ast_modem->send(p, cmd, 0)) {
 		ast_log(LOG_WARNING, "Unable to dial\n");
 		return -1;
 	}
@@ -419,13 +426,13 @@
 	if (aopen_break(p))
 		return -1;
 	/* Hangup by switching to data, then back to voice */
-	if (ast_modem_send(p, "ATH", 0) ||
-	     ast_modem_expect(p, "OK", 8)) {
+	if (ast_modem->send(p, "ATH", 0) ||
+	     ast_modem->expect(p, "OK", 8)) {
 		ast_log(LOG_WARNING, "Unable to set to data mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT#CLS=8", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT#CLS=8", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to voice mode\n");
 		return -1;
 	}
@@ -467,14 +474,15 @@
 	return res;
 }
 
+
 int load_module(void)
 {
-	return ast_register_modem_driver(&aopen_driver);
+	return ast_modem->register_driver(&aopen_driver);
 }
 
 int unload_module(void)
 {
-	return ast_unregister_modem_driver(&aopen_driver);
+	return ast_modem->unregister_driver(&aopen_driver);
 }
 
 char *description()
Index: channels/chan_modem_bestdata.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_modem_bestdata.c,v
retrieving revision 1.15
diff -u -r1.15 chan_modem_bestdata.c
--- channels/chan_modem_bestdata.c	21 Apr 2005 06:02:43 -0000	1.15
+++ channels/chan_modem_bestdata.c	25 May 2005 21:09:32 -0000
@@ -47,13 +47,19 @@
 	NULL
 };
 
+static struct ast_modem *ast_modem;
+struct symbol_entry required_symbols[] = {
+        MOD_WANT(ast_modem),
+        { NULL, NULL }
+};
+
 static int bestdata_break(struct ast_modem_pvt *p);
 
 static int bestdata_startrec(struct ast_modem_pvt *p)
 {
 	if (p->ministate != STATE_COMMAND) bestdata_break(p);
-	if (ast_modem_send(p, "AT+VRX", 0) ||
-	     ast_modem_expect(p, "CONNECT", 5)) {
+	if (ast_modem->send(p, "AT+VRX", 0) ||
+	     ast_modem->expect(p, "CONNECT", 5)) {
 		ast_log(LOG_WARNING, "Unable to start recording\n");
 		return -1;
 	}
@@ -64,8 +70,8 @@
 static int bestdata_startplay(struct ast_modem_pvt *p)
 {
 	if (p->ministate != STATE_COMMAND) bestdata_break(p);
-	if (ast_modem_send(p, "AT+VTX", 0) ||
-	     ast_modem_expect(p, "CONNECT", 5)) {
+	if (ast_modem->send(p, "AT+VTX", 0) ||
+	     ast_modem->expect(p, "CONNECT", 5)) {
 		ast_log(LOG_WARNING, "Unable to start recording\n");
 		return -1;
 	}
@@ -75,27 +81,27 @@
 
 static int bestdata_break(struct ast_modem_pvt *p)
 {
-	if (ast_modem_send(p, breakcmd, 2)) {
+	if (ast_modem->send(p, breakcmd, 2)) {
 		ast_log(LOG_WARNING, "Failed to break\n");
 		return -1;
 	}
 	p->ministate = STATE_COMMAND;
 	usleep(10000);
 	/* Read any outstanding junk */
-	while(!ast_modem_read_response(p, 1));
-	if (ast_modem_send(p, "AT", 0)) {
+	while(!ast_modem->read_response(p, 1));
+	if (ast_modem->send(p, "AT", 0)) {
 		/* Modem might be stuck in some weird mode, try to get it out */
-		ast_modem_send(p, "+++", 3);
-		if (ast_modem_expect(p, "OK", 10)) {
+		ast_modem->send(p, "+++", 3);
+		if (ast_modem->expect(p, "OK", 10)) {
 			ast_log(LOG_WARNING, "Modem is not responding\n");
 			return -1;
 		}
-		if (ast_modem_send(p, "AT", 0)) {
+		if (ast_modem->send(p, "AT", 0)) {
 			ast_log(LOG_WARNING, "Modem is not responding\n");
 			return -1;
 		}
 	}
-	if (ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Modem did not respond properly\n");
 		return -1;
 	}
@@ -110,38 +116,38 @@
 		return -1;
 	/* Force into command mode */
 	p->ministate = STATE_COMMAND;
-	if (ast_modem_send(p, "AT+FCLASS=8", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+FCLASS=8", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to voice mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT+VSM=1,8000,0,0", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VSM=1,8000,0,0", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to 8000 Hz sampling\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT+VLS=0", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VLS=0", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to telco interface\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT+VRA=" VRA, 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VRA=" VRA, 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to 'ringback goes away' timer\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT+VRN=" VRN, 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VRN=" VRN, 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to 'ringback never came timer'\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT+VTD=63", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VTD=63", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to tone detection\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT+VCID=1", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+VCID=1", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to enable Caller*ID\n");
 		return -1;
 	}
@@ -189,9 +195,9 @@
 		   {
 			char res[1000]="";
 
-			if (ast_modem_read_response(p, 5)) break;
+			if (ast_modem->read_response(p, 5)) break;
 			strncpy(res, p->response, sizeof(res)-1);
-			ast_modem_trim(res);
+			ast_modem->trim(res);
 			if (!strncmp(res,"\020.",2)) break;
 			if (!strncmp(res,"NAME",4)) strncpy(name,res + 7, sizeof(name) - 1);
 			if (!strncmp(res,"NMBR",4)) strncpy(nmbr,res + 7, sizeof(nmbr) - 1);
@@ -221,7 +227,7 @@
 		return &p->fr;
 	case 'o': /* Overrun */
 		ast_log(LOG_WARNING, "Overflow on modem, flushing buffers\n");
-		if (ast_modem_send(p, "\0x10E", 2)) 
+		if (ast_modem->send(p, "\0x10E", 2)) 
 			ast_log(LOG_WARNING, "Unable to flush buffers\n");
 		return &p->fr;	
 	case '0':  /* All the DTMF characters */
@@ -300,7 +306,7 @@
 				return bestdata_handle_escape(p, 0);
 			/* Read the rest of the line */
 			fgets(result + 2, sizeof(result) - 2, p->f);
-			ast_modem_trim(result);
+			ast_modem->trim(result);
 			if (!strcasecmp(result, "OK")) {
 				/* If we're in immediate mode, reply now */
 				if (p->mode == MODEM_MODE_IMMEDIATE)
@@ -421,21 +427,21 @@
 	char mfr[80];
 	char mdl[80];
 	char rev[80];
-	ast_modem_send(p, "AT+FMM", 0);
-	ast_modem_read_response(p, 5);
+	ast_modem->send(p, "AT+FMM", 0);
+	ast_modem->read_response(p, 5);
 	strncpy(mdl, p->response, sizeof(mdl)-1);
-	ast_modem_trim(mdl);
-	ast_modem_expect(p, "OK", 5);
-	ast_modem_send(p, "AT+FMI", 0);
-	ast_modem_read_response(p, 5);
+	ast_modem->trim(mdl);
+	ast_modem->expect(p, "OK", 5);
+	ast_modem->send(p, "AT+FMI", 0);
+	ast_modem->read_response(p, 5);
 	strncpy(mfr, p->response, sizeof(mfr)-1);
-	ast_modem_trim(mfr);
-	ast_modem_expect(p, "OK", 5);
-	ast_modem_send(p, "AT+FMR", 0);
-	ast_modem_read_response(p, 5);
+	ast_modem->trim(mfr);
+	ast_modem->expect(p, "OK", 5);
+	ast_modem->send(p, "AT+FMR", 0);
+	ast_modem->read_response(p, 5);
 	strncpy(rev, p->response, sizeof(rev)-1);
-	ast_modem_trim(rev);
-	ast_modem_expect(p, "OK", 5);
+	ast_modem->trim(rev);
+	ast_modem->expect(p, "OK", 5);
 	snprintf(identity, sizeof(identity), "%s Model %s Revision %s", mfr, mdl, rev);
 	return strdup(identity);
 }
@@ -460,8 +466,8 @@
 {
 	p->ringt = 0;
 	p->lastring = 0;
-	if (ast_modem_send(p, "AT+VLS=1", 0) ||
-	     ast_modem_expect(p, "OK", 10)) {
+	if (ast_modem->send(p, "AT+VLS=1", 0) ||
+	     ast_modem->expect(p, "OK", 10)) {
 		ast_log(LOG_WARNING, "Unable to answer: %s", p->response);
 		return -1;
 	}
@@ -474,8 +480,8 @@
 
 	if (p->ministate != STATE_COMMAND) bestdata_break(p);
 	snprintf(cmd, sizeof(cmd), "AT+VTS=%c", digit);
-	if (ast_modem_send(p, cmd, 0) ||
-	     ast_modem_expect(p, "OK", 10)) {
+	if (ast_modem->send(p, cmd, 0) ||
+	     ast_modem->expect(p, "OK", 10)) {
 		ast_log(LOG_WARNING, "Unable to answer: %s", p->response);
 		return -1;
 	}
@@ -515,7 +521,7 @@
 	   {
 		snprintf(cmd, sizeof(cmd), "ATD%c %s", p->dialtype,stuff);
 	   }
-	if (ast_modem_send(p, cmd, 0)) {
+	if (ast_modem->send(p, cmd, 0)) {
 		ast_log(LOG_WARNING, "Unable to dial\n");
 		return -1;
 	}
@@ -527,13 +533,13 @@
 	if (bestdata_break(p))
 		return -1;
 	/* Hangup by switching to data, then back to voice */
-	if (ast_modem_send(p, "ATH", 0) ||
-	     ast_modem_expect(p, "OK", 8)) {
+	if (ast_modem->send(p, "ATH", 0) ||
+	     ast_modem->expect(p, "OK", 8)) {
 		ast_log(LOG_WARNING, "Unable to set to data mode\n");
 		return -1;
 	}
-	if (ast_modem_send(p, "AT+FCLASS=8", 0) ||
-	     ast_modem_expect(p, "OK", 5)) {
+	if (ast_modem->send(p, "AT+FCLASS=8", 0) ||
+	     ast_modem->expect(p, "OK", 5)) {
 		ast_log(LOG_WARNING, "Unable to set to voice mode\n");
 		return -1;
 	}
@@ -581,12 +587,12 @@
 
 int load_module(void)
 {
-	return ast_register_modem_driver(&bestdata_driver);
+	return ast_modem->register_driver(&bestdata_driver);
 }
 
 int unload_module(void)
 {
-	return ast_unregister_modem_driver(&bestdata_driver);
+	return ast_modem->unregister_driver(&bestdata_driver);
 }
 
 char *description()
